/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2000.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2000-2004
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
*/

////////////////////////////////////////////////////////////////////////////////
function initTabContextMenu()
{
  var popupNode = document.popupNode;

  if (popupNode && popupNode.localName == 'toolbarbutton')
    popupNode = getBrowser().selectedTab;
  initGoogleBoxMenuitem("GoogleBoxToolbarsMenuitem");

  if (popupNode.hasAttribute("customLabel")) {
    document.getElementById("setStickyMenuItem").setAttribute("hidden", "true");
    document.getElementById("clearStickyMenuItem").removeAttribute("hidden");
  }
  else {
    document.getElementById("clearStickyMenuItem").setAttribute("hidden", "true");
    document.getElementById("setStickyMenuItem").removeAttribute("hidden");
  }
  initToolbarsMenu();
}
////////////////////////////////////////////////////////////////////////////////
function initToolbarsMenu()
{
  // Update Menu/View/Show-Hide to reflect the current state of the Tab Bar
  // We need this because we now use observes in our Toolbars menu
  var tabbarMenuItem = document.getElementById("menuitem_showhide_tabbar");
  var tabBarDisplayed = gBrowser.getStripVisibility();
  tabbarMenuItem.setAttribute("checked", tabBarDisplayed);
  // Overwrite the disabled state in updateToolbarStates() in navigator.js
  // This allows the user to hide/show the Tab Bar, at any time
  tabbarMenuItem.removeAttribute("disabled");
}
////////////////////////////////////////////////////////////////////////////////
function initTabImportMenu(importMenu)
{
  var navigatorWindows = 0;
  var item = importMenu.childNodes[1];
  var windowManagerDS = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService(nsIWindowDataSource);

  while ((item = item.nextSibling)) {
    var url = item.getAttribute('id');
    var win = windowManagerDS.getWindowForResource(url);

    if (win && win == window) {
      item.setAttribute("checked", "true");
      item.setAttribute("disabled", "true");
    }
    else {
      if (isNavigatorWindow(win))
        navigatorWindows++;
      else
        item.setAttribute("disabled", "true");
    }
  }
  importMenu.firstChild.setAttribute("disabled", (navigatorWindows < 2) ? "true" : "false");
}
////////////////////////////////////////////////////////////////////////////////
function importTabsByWindowId(aWindowId)
{
  var windowManagerDS = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService(nsIWindowDataSource);

  var win = windowManagerDS.getWindowForResource(aWindowId);
  if (!win || win == window || !isNavigatorWindow(win)) 
    return;
  var winBrowser = win.getBrowser().mPanelContainer;
  var tabCounter = winBrowser.childNodes.length;

  for (var i = 0; i < tabCounter; i++) {
    var url = winBrowser.childNodes[i].currentURI.spec;
    if (url && url != "about:blank")
      getBrowser().addTab(url);
  }
}
////////////////////////////////////////////////////////////////////////////////
function importAllTabs(aMenuitem)
{
  while ((aMenuitem = aMenuitem.nextSibling)) {
    importTabsByWindowId(aMenuitem.getAttribute('id'));
  }
}
////////////////////////////////////////////////////////////////////////////////
function initTabExportMenu(aParent) 
{
  var tabContainer = gBrowser.mTabContainer; 
  var panelContainer = gBrowser.mPanelContainer; 
  var tabCounter = tabContainer.childNodes.length;

  deleteHistoryItems(aParent); // depends on sessionHistoryUI.js

  for (var i = 0; i < tabCounter; i++) {
    var tabURL = panelContainer.childNodes[i].currentURI.spec;
    var tabLabel = tabContainer.childNodes[i].label;
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", tabLabel);
    menuitem.setAttribute("url", tabURL);
    menuitem.setAttribute("index", i); // make deleteHistoryItems() work
    menuitem.setAttribute("oncommand", "exportTab(this)");
    aParent.appendChild(menuitem);

    if (tabURL == "about:blank")
      menuitem.setAttribute("disabled", "true");
  }
  aParent.firstChild.setAttribute("disabled", (aParent.childNodes.length == 3) ? "true" : "false");
}
////////////////////////////////////////////////////////////////////////////////
function exportTab(aMenuitem)
{
  if (!aMenuitem.hasAttribute("disabled"))
    window.open(aMenuitem.getAttribute("url"));
}
////////////////////////////////////////////////////////////////////////////////
function exportAllTabs(aMenuitem)
{
  while ((aMenuitem = aMenuitem.nextSibling)) {
    exportTab(aMenuitem)
  }
}