/* 
   - The Original Code is this file as it was released on Februari 6, 2004.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2004
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
*/

var gHeight, gScreenX, gScreenY, gPanel, gPanelName, gModified = false;
var gEnableState, gNavigator, gTabbrowser, gDocument, gPermissionManager, gEscapePressed = false;
var gSecondLevelPrefs = false;

if (hPrefWindow == undefined) // Fixing breakage caused by mozilla bug 228904
  var hPrefWindow = null;

function Startup()
{
  gPermissionManager = window.arguments[0];
  gScreenX = gPermissionManager.screenX;
  gScreenY = gPermissionManager.screenY;
  gHeight = (gPermissionManager.innerHeight / 50 - 2)
  gPanel = gPermissionManager.dialogType;

  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
                                .getService(Components.interfaces.nsIWindowMediator);
  try { // Catch "undefined xyz" JS errors
    gNavigator = windowManager.getMostRecentWindow("navigator:browser");
    gTabbrowser = gNavigator.getBrowser();
    gDocument = gTabbrowser.contentDocument;
  } catch(ex) {
    gPermissionManager.open();
    gNavigator = windowManager.getMostRecentWindow("navigator:browser");
    gTabbrowser = gNavigator.getBrowser();
  }
  document.documentElement.setAttribute("hidechrome", "true");
  window.outerWidth = gPermissionManager.innerWidth;
  window.outerHeight = 0;
  // window.moveTo(screenX, screenY);

  if (!hPrefWindow) // Fixing breakage caused by mozilla bug 228904
    hPrefWindow = new nsPrefWindow('panelFrame');
    
  if (!hPrefWindow)
    throw "Permissions Manager Failed to Create its Pref Window";
  hPrefWindow.init();
  document.getElementById('mac_button_spring').hidden = !(/Mac/.test(navigator.platform));
  document.getElementById(hPrefWindow.contentFrame).setAttribute("tag", gPanel);
  switchPanel(gPanel);
  slideOpen(0);
}

function slideOpen(aStep) // Modified Phoenix code!
{
  if (aStep < gHeight) {
    window.outerHeight += 50;
    setTimeout(slideOpen, 20, ++aStep);
  } else {
    window.outerHeight = gPermissionManager.innerHeight;
    document.getElementById("main-box").collapsed = false;
  }
}

function slideClosed(aStep) // Modified Phoenix code!
{
  if (aStep < gHeight) {
    window.outerHeight -= 50;
    setTimeout(slideClosed, 10, ++aStep);
  } else {
    window.close();
  }
}

function initPanel()
{
  for (i in gPermissionManager.permissionTypes) {
    if (gPanel.match(gPermissionManager.permissionTypes[i]))
      break;
  }
  gPanelName = gPermissionManager.capabilityTextID[i];
  var headertitle = window.frames[hPrefWindow.contentFrame].document.getElementsByAttribute("headertitle", "*");
  headertitle[0].setAttribute("headertitle", gPermissionManager.capabilityTextID[i]);

  if (hPrefWindow)
    hPrefWindow.onpageload(gPanel);
  else
    queuedTag = gPanel;
}

function switchPanel(aPanel)
{
  gPanel = aPanel; // gPanel = current panel / aPanel = new panel
  var categoryButton = gPanel;
  var panelFile, panelPath = "chrome://multiviews/content/perm-manager/pref/";

  switch(gPanel) {
    case "cookie": 
         panelFile = "permissionManagerCookiePanel.xul";
         gSecondLevelPrefs = false;
         break;
    case "mozilla-image-prefs":
         // "content blocker image pref panel" : "mozilla image pref panel"
         panelFile = gSecondLevelPrefs ? "permissionManagerMainPanel.xul" : "permissionManagerImagePanel.xul";
         gSecondLevelPrefs = !gSecondLevelPrefs;
         categoryButton = "image";

         if (!gSecondLevelPrefs)
           gPanel = categoryButton;
         break;
    case "popup": 
    case "mozilla-popup-prefs": 
         // "content blocker popup pref panel" : "mozilla popup pref panel"
         // panelFile = gSecondLevelPrefs ? "permissionManagerPopupPanel.xul" : "permissionManagerPopupMorePanel.xul";
         panelFile = "permissionManagerPopupMorePanel.xul";
         // gSecondLevelPrefs = !gSecondLevelPrefs;
         gSecondLevelPrefs = false; // This should be removed when 'More Prefs' is ready!
         categoryButton = "popup";

         if (!gSecondLevelPrefs)
           gPanel = categoryButton;
         break;
    default:
         panelFile = "permissionManagerMainPanel.xul";
         gSecondLevelPrefs = false;
  }
  var panelURL = panelPath + panelFile;
  var contentFrame = document.getElementById(hPrefWindow.contentFrame);
  // Save pref panel settings
  var currentPanel = contentFrame.getAttribute("tag");
  hPrefWindow.wsm.savePageData(currentPanel, null);
  contentFrame.setAttribute("tag", gPanel);
  // Reload/reinitialize pref panel
  contentFrame.removeAttribute("src");
  contentFrame.setAttribute("src", panelURL);
  // Display 'Back' button for secondary level pref panels
  document.getElementById('backButton').hidden = !gSecondLevelPrefs;
  // Hide 'Cancel' button for secondary pref panels
  document.documentElement.getButton('cancel').hidden = gSecondLevelPrefs;
  // Update label and default attribute for modified pref panels
  if (gModified)
    hasModifiedPrefs();
  else
    selectDefaultButton();
  // Select category button
  categoryButton = document.getElementById(categoryButton);
  categoryButton.checked = true;
}

function selectSecondaryPrefPanel()
{
  if (gPanel.match("image")) // "image" or "mozilla-image-prefs"
    switchPanel("mozilla-image-prefs");
  else if (gPanel.match("popup")) // "popup" or "mozilla-popup-prefs"
    switchPanel("mozilla-popup-prefs");
}

function preExitCall(aEvent, aFlag)
{
  if (gModified && aFlag || gModified && gEscapePressed) {
    hasModifiedPrefs('no');

    if (gPermissionManager.getConfirmation(window, 'cbWizard', 'cbConfirmCloseText')) {
      if ("onOK" in hPrefWindow) // Fixing breakage caused by mozilla bug 228904
        hPrefWindow.onOK(aEvent);
      else
        hPrefWindow.onAccept(aEvent);
    }
  }
  document.getElementById("main-box").collapsed = true;
  gPermissionManager.switchTree(gPanel);
  slideClosed(0);
}

function onAccept(aEvent)
{
  preExitCall(aEvent, false);

  if ("onOK" in hPrefWindow) // Fixing breakage caused by mozilla bug 228904
    hPrefWindow.onOK(aEvent);
  else 
    hPrefWindow.onAccept(aEvent);
}

function onCancel(aEvent, aFlag)
{
  preExitCall(aEvent, aFlag);

  if (!gEscapePressed)
    hPrefWindow.onCancel(aEvent);
}

function hasModifiedPrefs(aState)
{
  var acceptButton = document.documentElement.getButton('accept');
  gModified = (aState == "no") ? false : true;
  acceptButton.disabled = !gModified;

  if (gSecondLevelPrefs)
    defaultButton = document.getElementById('backButton');
  else {
    var cancelButton = document.documentElement.getButton('cancel');
    cancelButton.label = gPermissionManager.permissionsBundle.GetStringFromName('pmCancelButton.label');
    cancelButton.accessKey = gPermissionManager.permissionsBundle.GetStringFromName('pmCancelButton.accesskey');
  }
  selectDefaultButton();
}

function selectDefaultButton()
{
  var defaultButton;
  var backButton = document.getElementById('backButton');
  var acceptButton = document.documentElement.getButton('accept');
  var cancelButton = document.documentElement.getButton('cancel');

  backButton.removeAttribute('default');
  acceptButton.removeAttribute('default');
  cancelButton.removeAttribute('default');

  if (gSecondLevelPrefs)
    defaultButton = backButton;
  else
    defaultButton = cancelButton;

  if (gModified)
    defaultButton = acceptButton;
  defaultButton.setAttribute('default', 'true');
  defaultButton.focus();
}

function mzSpinButton(aDocument, aElementId, aStepValue, aMinValue, aMaxValue)
{
  /***
    * The 'onup' and 'ondown' buttons/images are always functional, even 
    * when disabled, so we need to check this to prevent failures!
    */
  if (!aDocument || !aElementId)
    return;
  var spinbutton = aDocument.getElementById(aElementId);

  if (!spinbutton || spinbutton.disabled)
    return;

  var newValue = Number(spinbutton.value) + Number(aStepValue);
  spinbutton.value = (newValue > (aMinValue-1) && newValue < (aMaxValue+1)) ? newValue : (newValue < aMinValue) ? aMaxValue : aMinValue;
  hasModifiedPrefs();
}
